# print the ids of all protein pairs in a given genome that

# - are multidomain and identical, clan-wise
# - are multidomain and non-overlapping, clan-wise

# first argument is the Pfam-C file
# second argument is an architecture file, formatted such as
# <protein id> <PFXXXXX*PFXXXXX*PFYYYYY>
# in which any collapsing of repeat/motif domains should already have been performed

open (FH, $ARGV [0]); # pfam-C

%clans = ();

while (<FH>) {

 $aLine = $_;
 chomp ($aLine);

 if ($aLine =~ /AC\s*(CL\d*)\./) {

  $clan = $1;

 }

 if ($aLine =~ /MB\s*(PF\d{5})\;/) {

  $clans {$1} = $clan;

 }

}

close (FH);

open (FH, $ARGV [1]); # architecture file

%archs = ();

while (<FH>) {

 $aLine = $_;
 chomp ($aLine);

 @words = split (/\s/, $aLine);

 $id = $words [0];

 @doms = split (/\*/, $words [1]);

 if (@doms > 1) {

  $archs {$id} = $words [1];

 }

}

close (FH);

@ids = keys % archs;

for ($i = 0; $i < @ids - 1; $i++) {

 for ($j = $i; $j < @ids; $j++) {

  $id1 = $ids [$i];
  $id2 = $ids [$j];

  $arch1 = $archs {$ids [$i]};
  $arch2 = $archs {$ids [$j]};

  @aarch1 = split (/\*/, $arch1);
  @aarch2 = split (/\*/, $arch2);

  if (@aarch1 == @aarch2) {

   $iss = 1;

   for ($k = 0; $k < @aarch1; $k++) {

    if (exists ($clans {$aarch1 [$k]}) && exists ($clans {$aarch2 [$k]})) {

     if (! ($clans {$aarch1 [$k]} eq $clans {$aarch2 [$k]})) {

      $iss = 0;

     }

    }

    else {

     if (! ($aarch1 [$k] eq $aarch2 [$k])) {

      $iss = 0;

     }

    }

   }

   if ($iss == 1) {

    print "same\t$id1\t$id2\t$arch1\t$arch2\n";
#    print "same\t$id1\t$id2\n";

   }

  }  

  $iss = 0;

  for ($k = 0; $k < @aarch1; $k++) {

   for ($l = 0; $l < @aarch2; $l++) {

    if (($aarch1 [$k] eq $aarch2 [$l]) || (exists ($clans {$aarch1 [$k]}) && exists ($clans {$aarch2 [$l]}) && ($clans {$aarch1 [$k]} eq $clans {$aarch2 [$l]}))) {

     $iss = 1;
 
    }

   }

  }

  if ($iss == 0) {

    print "diff\t$id1\t$id2\t$arch1\t$arch2\n";
#    print "diff\t$id1\t$id2\n";

  }
  
 }

}
